#include <HT32F125x.h>                    // 

/* Fijarse en Project -> Options -> C/C++ Compiler -> Preprocessor
los paths para agregar el CMSIS y que el IAR lo incluya 
est en $TOOLKIT_DIR$/CMSIS porque yo (SRC) lo puse ahi */

#include "SSD1963.h"

#include <math.h>
#define m_PI 3.14159265358979323846264338327
#include <stdio.h>


volatile unsigned long SysTickCnt;      // SysTick Counter

// SysTick Setup
void SysTick_Setup (void)
{
  SysTick->LOAD = 72000 - 1;            // 1ms: 72000 ticks @ 72MHz
  SysTick->CTRL = 0x0007;               // Enable Counter and Tick Interrupt
}

// SysTick Interrupt Handler (tick each 1ms)
void SysTick_Handler (void)
{
  SysTickCnt++;
}


// Delay Function
void Delay (unsigned long tick)
{
unsigned long systickcnt;

  systickcnt = SysTickCnt;
  while ((SysTickCnt - systickcnt) < tick);
}
#define MsDelay Delay

void QUADS(void)
{
	LCD_setwindow ( 0, 319, 0, 239);
	LCD_WriteCmd(0x2C);
  	LCD_WriteArea(RED,320UL*240);	//
	LCD_setwindow ( 320, 639, 0, 239);
	LCD_WriteCmd(0x2C);
  	LCD_WriteArea(BLUE,320UL*240);	//
	LCD_setwindow ( 0, 319, 240, 479);
	LCD_WriteCmd(0x2C);
  	LCD_WriteArea(CYAN,320UL*240);	//
	LCD_setwindow ( 320, 639, 240, 479);
	LCD_WriteCmd(0x2C);
  	LCD_WriteArea(GREEN,320UL*240);	//
	LCD_setwindow ( 0, 639, 0, 479);
}

/* simple 3D function plotting */

void paraboloide(int PERSP,float SCALE,int TRAZOSX,int TRAZOSY,float X0,float X1,float Y0,float Y1,uint32_t pcolor)
{
auto int xx,yy;
auto float x,y,z;
auto float persp,xt,zt;
auto float h1,h2,h3,h4,cs,si;

	persp=PERSP*0.01745329;			// convert to radians
	cs=cos(persp);
	si=sin(persp);
	h1=(X1-X0)/159;
	h2=(Y1-Y0)/(float)(TRAZOSX-1);
	h3=(X1-X0)/(float)(TRAZOSY-1);
	h4=(Y1-Y0)/159;

	for(y=Y0;y<=Y1;y+=h2)
		for(x=X0;x<=X1;x+=h1){
			z=x*x/4+y*y/9-15;
			xt=x-y*cs;
			zt=z-y*si;
			xx=320+(int)(SCALE*xt);
			yy=240-(int)(SCALE*zt);
			LCD_plot(xx,yy,pcolor);
		}
	for(x=X0;x<=X1;x+=h3)
		for(y=Y0;y<=Y1;y+=h4) {
			z=x*x/4+y*y/9-15;
			xt=x-y*cs;
			zt=z-y*si;
			xx=320+(int)(SCALE*xt);
			yy=240-(int)(SCALE*zt);
			LCD_plot(xx,yy,pcolor);
		}
}

void elipsoide(int PERSP,float SCALE,int TRAZOSX,int TRAZOSY,float X0,float X1,float Y0,float Y1,uint32_t pcolor)
{
auto int xx,yy;
auto float x,y;
auto float persp,xt,yt,zt;
auto float h1,h2,h3,h4,cs,si;

	persp=PERSP*0.01745329;			// convert to radians
	cs=cos(persp);
	si=sin(persp);
	h1=(X1-X0)/159;
	h2=(Y1-Y0)/(float)(TRAZOSX-1);
	h3=(X1-X0)/(float)(TRAZOSY-1);
	h4=(Y1-Y0)/159;

	for(y=Y0;y<=Y1;y+=h2)
		for(x=X0;x<=X1;x+=h1){
			xt=cos(x)*cos(y);
			yt=sin(x)*cos(y);
			zt=sin(y);
			xt-=yt*cs;
			zt-=yt*si;
			xx=320+(int)(SCALE*xt);
			yy=240-(int)(SCALE*zt);
			LCD_plot(xx,yy,pcolor);
		}
	for(x=X0;x<=X1;x+=h3)
		for(y=Y0;y<=Y1;y+=h4) {
			xt=cos(x)*cos(y);
			yt=sin(x)*cos(y);
			zt=sin(y);
			xt-=yt*cs;
			zt-=yt*si;
			xx=320+(int)(SCALE*xt);
			yy=240-(int)(SCALE*zt);
			LCD_plot(xx,yy,pcolor);
		}
}

void pattern(void)
{
uint16_t x,y;
uint8_t r,g,b;

	LCD_WriteCmd(0x2C);
  	for(y=0;y<480;y++,g++){
	   	if(y>255)
      			b++;
	for(x=0;x<640;x++,r++){
	   	if(x>255)
   		   	b++;
	      	LCD_WritePixel(MAKECOLOR(r,g,b));
	}
   }
}

//#include "tal_img.h"

/* MAIN PROGRAM */

main()
{
unsigned int i,y,oldy;
char string[5];


	SysTick_Setup();                      // SysTick Setup
	LCD_init();

	while(1){
		LCD_fill(640,480,RED);		// R
		LCD_fill(640,480,GREEN);		// G
		LCD_fill(640,480,BLUE);		// B
		QUADS();
		pattern();
 		LCD_clear();
#if 0
		LCD_icon(160,80,320,305,(uint8_t *)tal);			// show gfx
		LCD_printat(1,420,320,"Tal Wilkenfeld",0x2045C2,0xB33018);
		MsDelay ( 15000 );						// wait 15 secs
 		LCD_clear();
#endif
		LCD_rectangle(0,0,639,479,GRAY);
 		for(i=0;i<16;i++) {
			LCD_rectangle(21*i+3,11*i+3,17*i+240,11*i+81,RED);
			LCD_rectangle(13*i+5,13*i+5,19*i+240,13*i+83,GREEN);
		}
		MsDelay ( 1000 );						// wait 1 secs
		LCD_clear();
		LCD_rectangle(10,5,128,45,RED);
		LCD_rectangle(8,3,130,47,GREEN);
		LCD_printat(0,20,20,"Cika Electronica",BLUE,0x000000);
		MsDelay ( 3000 );						// wait 5 secs
		LCD_clear();
		paraboloide(30,12,20,20,-8.0,8.0,-10.0,10.0,BLUE);
		LCD_printat(1,20,20,"Cika Electronica",GREEN,0xff0000);
		MsDelay ( 5000 );	 					// wait 5 secs
		elipsoide(45,160.0,30,30,0,6.28,-3.14,3.14,RED);
		LCD_printat(1,50,100,"Cika Electronica",GREEN,-1);
		MsDelay ( 5000 );						// wait 5 secs
		LCD_clear();
		LCD_line(0,240,639,240,GRAY);
		for(i=0;i<640;i++){
			oldy=y;
			y=(uint16_t)(240-239*sin((2*m_PI*i)/640)*cos((17*m_PI*i)/640));
			if(i==0)
				LCD_plot(i,y,GREEN);
			else
				LCD_line(i-1,oldy,i,y,GREEN);
		}
		for(i=0;i<640;i++){
			oldy=y;
			y=(uint16_t)(240+239*cos((5*m_PI*i)/640)*cos((m_PI*i)/640));
			if(i==0)
			  	LCD_plot(i,y,RED);
			else
				LCD_line(i-1,oldy,i,y,RED);
		}
		for(i=0;i<640;i++){
			oldy=y;
			y=(uint16_t)(240-239*sin(cos(tan(cos((2*m_PI*i)/640)))));
			if(i==0)
				LCD_plot(i,y,BLUE);
			else
				LCD_line(i-1,oldy,i,y,BLUE);
		}
		for(i=0;i<10;i++){
			LCD_line(64*i,235,64*i,245,GRAY);
			sprintf(string,"%d",i);
			LCD_printat(0,250,64*i,string,GRAY,-1);
		}
		LCD_printat(1,0,0,"Dermopirifilacion",WHITE,-1);
		LCD_printat(1,0,500,"Sensor A",RED,-1);
		LCD_printat(1,20,500,"Sensor B",GREEN,-1);
		LCD_printat(1,40,500,"Sensor C",BLUE,-1);
		MsDelay ( 10000 );						// wait 10 secs
		LCD_setwindow ( 0, 639, 0, 479);
	}
}
